---------------------------------------------------------------------------------
--
-- New Tables for release 3.2.2.3 (3.2 M2 HF3)
-- 
-- Tables to Support the New "Expression" Rule
---------------------------------------------------------------------------------

---------------------------------------------------------------------------------
--****** Tablespace information for DATA and Indexes must be defined, prior to running this script ********
-- Replace [TBSPACE] with the appropriate data tablespace name
-- Replace [INDEX_TBSPACE] with the appropriate index tablespace name
--
-- NOTE:
-- The FRH_EXPRESSION_ARGUMENTS table must be created with a 32K INDEX tablespace, because the 
-- UNIQUE INDEX AKX1_EXPR, on the table, will require a 32K tablespace. Reference SQLCODE SQL0614N
-- in the db2 documentation for information around this requirement.
---------------------------------------------------------------------------------

------------------------------------------------
-- DDL Statements for table FRH_EXPRESSION_ALERT
------------------------------------------------
 

CREATE TABLE FRH_EXPRESSION_ALERT  (
                  EXPRESSION_ALERT_ID BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY (
                    START WITH +50100
                    INCREMENT BY +1
                    MINVALUE +50100
                    MAXVALUE +9007199254740991
                    NO CYCLE
                    CACHE 20
                    NO ORDER ) ,
                  CMX_TRAN_ID BIGINT NOT NULL ,
                  ENTITY_VALUE CHAR(34) NOT NULL ,
                  RULE_ID INTEGER NOT NULL ,
                  RULE_VERSION_NBR INTEGER NOT NULL ,
                  HIGHLIGHT_TRAN_ID     BIGINT,
                  HIGHLIGHT_EXPRESSION_ID       BIGINT,
                  LINK_TRAN_ID  BIGINT,
                  LINK_EXPRESSION_ID    BIGINT,
                  CREATE_TIMESTAMP TIMESTAMP NOT NULL WITH DEFAULT CURRENT_TIMESTAMP )
		IN [TBSPACE] INDEX IN [INDEX_TBSPACE]; 

CREATE UNIQUE INDEX PKX_EXPR_ALRT
 ON FRH_EXPRESSION_ALERT ( EXPRESSION_ALERT_ID ASC )
  ALLOW REVERSE SCANS PCTFREE 10 CLUSTER;

CREATE  INDEX NDX1_EXPR_ALRT
 ON FRH_EXPRESSION_ALERT ( CMX_TRAN_ID ASC )
  ALLOW REVERSE SCANS PCTFREE 10 ;
  
ALTER TABLE FRH_EXPRESSION_ALERT
     ADD CONSTRAINT PKX_EXPR_ALRT PRIMARY KEY ( EXPRESSION_ALERT_ID );  
------------------------------------------------
-- DDL Statements for table FRH_EXPRESSION_ARGUMENTS
------------------------------------------------


CREATE TABLE FRH_EXPRESSION_ARGUMENTS  (
                  EXPRESSION_ID BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY (
                    START WITH +50100
                    INCREMENT BY +1
                    MINVALUE +50100
                    MAXVALUE +9007199254740991
                    NO CYCLE
                    CACHE 20
                    NO ORDER ) ,
                  RULE_TEMPLATE_ID BIGINT NOT NULL ,
                  EXPRESSION_ARG_1 VARCHAR(100)  ,
                  EXPRESSION_ARG_2 VARCHAR(100)  ,
                  EXPRESSION_ARG_3 VARCHAR(100)  ,
                  EXPRESSION_ARG_4 VARCHAR(100)  ,
                  EXPRESSION_ARG_5 VARCHAR(100)  ,
                  EXPRESSION_ARG_6 VARCHAR(100)  ,
                  EXPRESSION_ARG_7 VARCHAR(100)  ,
                  EXPRESSION_ARG_8 VARCHAR(100)  ,
                  EXPRESSION_ARG_9 VARCHAR(100)  ,
                  EXPRESSION_ARG_10 VARCHAR(100)  ,
                  EXPRESSION_ARG_11 VARCHAR(100)  ,
                  EXPRESSION_ARG_12 VARCHAR(100)  ,
                  EXPRESSION_ARG_13 VARCHAR(100)  ,
                  EXPRESSION_ARG_14 VARCHAR(100)  ,
                  EXPRESSION_ARG_15 VARCHAR(100)  ,
                  EXPRESSION_ARG_16 VARCHAR(100)  ,
                  EXPRESSION_ARG_17 VARCHAR(100)  ,
                  EXPRESSION_ARG_18 VARCHAR(100)  ,
                  EXPRESSION_ARG_19 VARCHAR(100)  ,
                  EXPRESSION_ARG_20 VARCHAR(100)  ,
                  EXPRESSION_ARG_21 VARCHAR(100)  ,
                  EXPRESSION_ARG_22 VARCHAR(100)  ,
                  EXPRESSION_ARG_23 VARCHAR(100)  ,
                  EXPRESSION_ARG_24 VARCHAR(100)  ,
                  EXPRESSION_ARG_25 VARCHAR(100)  ,
                  EXPRESSION_ARG_26 VARCHAR(100)  ,
                  EXPRESSION_ARG_27 VARCHAR(100)  ,
                  EXPRESSION_ARG_28 VARCHAR(100)  ,
                  EXPRESSION_ARG_29 VARCHAR(100)  ,
                  EXPRESSION_ARG_30 VARCHAR(100)  ,
                  EXPRESSION_ARG_31 VARCHAR(100)  ,
                  EXPRESSION_ARG_32 VARCHAR(100)  ,
                  CREATE_TIMESTAMP TIMESTAMP NOT NULL WITH DEFAULT CURRENT_TIMESTAMP,
                  LSTUPDT_TIMESTAMP TIMESTAMP ,
                  LOGICAL_DEL_IND CHAR(1) NOT NULL WITH DEFAULT '0' )     
		IN [TBSPACE] INDEX IN [INDEX_TBSPACE];                   

CREATE UNIQUE INDEX PKX_EXPR
 ON FRH_EXPRESSION_ARGUMENTS ( EXPRESSION_ID ASC )
  ALLOW REVERSE SCANS PCTFREE 10 ;

CREATE UNIQUE INDEX AKX1_EXPR
 ON FRH_EXPRESSION_ARGUMENTS ( RULE_TEMPLATE_ID
			,EXPRESSION_ARG_1
			,EXPRESSION_ARG_2
			,EXPRESSION_ARG_3
			,EXPRESSION_ARG_4
			,EXPRESSION_ARG_5
			,EXPRESSION_ARG_6
			,EXPRESSION_ARG_7
			,EXPRESSION_ARG_8
			,EXPRESSION_ARG_9
			,EXPRESSION_ARG_10
			,EXPRESSION_ARG_11
			,EXPRESSION_ARG_12
			,EXPRESSION_ARG_13
			,EXPRESSION_ARG_14
			,EXPRESSION_ARG_15
			,EXPRESSION_ARG_16
			,EXPRESSION_ARG_17
			,EXPRESSION_ARG_18
			,EXPRESSION_ARG_19
			,EXPRESSION_ARG_20
			,EXPRESSION_ARG_21
			,EXPRESSION_ARG_22
			,EXPRESSION_ARG_23
			,EXPRESSION_ARG_24
			,EXPRESSION_ARG_25
			,EXPRESSION_ARG_26
			,EXPRESSION_ARG_27
			,EXPRESSION_ARG_28
			,EXPRESSION_ARG_29
			,EXPRESSION_ARG_30
			,EXPRESSION_ARG_31
			,EXPRESSION_ARG_32 ASC )
  ALLOW REVERSE SCANS PCTFREE 10 CLUSTER;
  
ALTER TABLE FRH_EXPRESSION_ARGUMENTS
     ADD CONSTRAINT CK_CHAR_ZERO_ONE
    CHECK (LOGICAL_DEL_IND IN ('0', '1')) ENFORCED ENABLE QUERY OPTIMIZATION;

ALTER TABLE FRH_EXPRESSION_ARGUMENTS
     ADD CONSTRAINT PKX_EXPR PRIMARY KEY ( EXPRESSION_ID );
  
------------------------------------------------
-- DDL Statements for table FRH_EXPRESSION_RESULTS
------------------------------------------------


CREATE TABLE FRH_EXPRESSION_RESULTS  (
                  EXPRESSION_ID BIGINT NOT NULL ,
                  STRING_RESULT VARCHAR(60) ,
                  LONG_RESULT BIGINT ,
                  CREATE_TIMESTAMP TIMESTAMP NOT NULL WITH DEFAULT  CURRENT_TIMESTAMP )  
		IN [TBSPACE] INDEX IN [INDEX_TBSPACE];                   



CREATE  INDEX NDX1_EXPR_RESLTS
 ON FRH_EXPRESSION_RESULTS ( EXPRESSION_ID ASC )
  ALLOW REVERSE SCANS PCTFREE 10 ;
  









