---------------------------------------------------------------------------------
--****** Tablespace information for DATA and Indexes must be defined, prior to running this script ********
-- Replace [TBSPACE] with the appropriate data tablespace name
-- Replace [INDEX_TBSPACE] with the appropriate index tablespace name
---------------------------------------------------------------------------------

------------------------------------------------
-- DDL Statements for table FCM_EXPRESSION_TEMPLATE
------------------------------------------------
 

CREATE TABLE FCM_EXPRESSION_TEMPLATE  (
		  EXPRESSION_TEMPLATE_ID BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY (  
		    START WITH +50100  
		    INCREMENT BY +1  
		    MINVALUE +50100  
		    MAXVALUE +9007199254740991  
		    NO CYCLE  
		    CACHE 200  
		    NO ORDER ) , 
		  RULE_ID BIGINT NOT NULL , 
		  TRANSACTION_ACRONYM CHARACTER(4)	NOT NULL, 
		  TEMPLATE_TEXT VARCHAR(4000) NOT NULL )
		IN [TBSPACE] INDEX IN [INDEX_TBSPACE]; 
		  
CREATE UNIQUE INDEX PKX_EXPR_TMPLT
 ON FCM_EXPRESSION_TEMPLATE ( EXPRESSION_TEMPLATE_ID ASC )
  ALLOW REVERSE SCANS PCTFREE 10 CLUSTER;

CREATE  INDEX NDX1_EXPR_TMPLT
 ON FCM_EXPRESSION_TEMPLATE ( RULE_ID ASC )
  ALLOW REVERSE SCANS PCTFREE 10 ;


ALTER TABLE FCM_EXPRESSION_TEMPLATE
     ADD CONSTRAINT PKX_EXPR_TMPLT PRIMARY KEY ( EXPRESSION_TEMPLATE_ID );
     
ALTER TABLE FCM_EXPRESSION_TEMPLATE
  ADD CONSTRAINT FK_EXPR_TMPLT_RULE FOREIGN KEY
     (RULE_ID)
  REFERENCES FCM_RULE
    (RULE_ID)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION
    ENFORCED ENABLE QUERY OPTIMIZATION;
    
