---------------------------------------------------------------------------------
--
-- New Tables for release 3.2.2.3 (3.2 M2 HF3)
-- 
-- Tables to Support the New "Expression" Rule
---------------------------------------------------------------------------------

------------------------------------------------
-- DDL Statements for table FRH_EXPRESSION_ALERT
------------------------------------------------
CREATE TABLE FRH_EXPRESSION_ALERT, NO FALLBACK   (
                  EXPRESSION_ALERT_ID BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY (
                    START WITH +50100
                    INCREMENT BY +1
                    MINVALUE +50100
                    MAXVALUE +9007199254740991
                    NO CYCLE ),                    
                  CMX_TRAN_ID BIGINT NOT NULL ,
                  ENTITY_VALUE CHAR(34) NOT NULL ,
                  RULE_ID INTEGER NOT NULL ,
                  RULE_VERSION_NBR INTEGER NOT NULL ,
                  HIGHLIGHT_TRAN_ID     BIGINT,
                  HIGHLIGHT_EXPRESSION_ID       BIGINT,
                  LINK_TRAN_ID  BIGINT,
                  LINK_EXPRESSION_ID    BIGINT,
                  CREATE_TIMESTAMP TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP )
UNIQUE PRIMARY INDEX ( EXPRESSION_ALERT_ID )
 ;
 COMMIT WORK;

------------------------------------------------
-- DDL Statements for table FRH_EXPRESSION_ARGUMENTS
------------------------------------------------
CREATE TABLE FRH_EXPRESSION_ARGUMENTS, NO FALLBACK   (
                  EXPRESSION_ID BIGINT NOT NULL GENERATED BY DEFAULT AS IDENTITY (
                    START WITH +50100
                    INCREMENT BY +1
                    MINVALUE +50100
                    MAXVALUE +9007199254740991
                    NO CYCLE ),
                  RULE_TEMPLATE_ID BIGINT NOT NULL ,
                  EXPRESSION_ARG_1 VARCHAR(100)  ,
                  EXPRESSION_ARG_2 VARCHAR(100)  ,
                  EXPRESSION_ARG_3 VARCHAR(100)  ,
                  EXPRESSION_ARG_4 VARCHAR(100)  ,
                  EXPRESSION_ARG_5 VARCHAR(100)  ,
                  EXPRESSION_ARG_6 VARCHAR(100)  ,
                  EXPRESSION_ARG_7 VARCHAR(100)  ,
                  EXPRESSION_ARG_8 VARCHAR(100)  ,
                  EXPRESSION_ARG_9 VARCHAR(100)  ,
                  EXPRESSION_ARG_10 VARCHAR(100)  ,
                  EXPRESSION_ARG_11 VARCHAR(100)  ,
                  EXPRESSION_ARG_12 VARCHAR(100)  ,
                  EXPRESSION_ARG_13 VARCHAR(100)  ,
                  EXPRESSION_ARG_14 VARCHAR(100)  ,
                  EXPRESSION_ARG_15 VARCHAR(100)  ,
                  EXPRESSION_ARG_16 VARCHAR(100)  ,
                  EXPRESSION_ARG_17 VARCHAR(100)  ,
                  EXPRESSION_ARG_18 VARCHAR(100)  ,
                  EXPRESSION_ARG_19 VARCHAR(100)  ,
                  EXPRESSION_ARG_20 VARCHAR(100)  ,
                  EXPRESSION_ARG_21 VARCHAR(100)  ,
                  EXPRESSION_ARG_22 VARCHAR(100)  ,
                  EXPRESSION_ARG_23 VARCHAR(100)  ,
                  EXPRESSION_ARG_24 VARCHAR(100)  ,
                  EXPRESSION_ARG_25 VARCHAR(100)  ,
                  EXPRESSION_ARG_26 VARCHAR(100)  ,
                  EXPRESSION_ARG_27 VARCHAR(100)  ,
                  EXPRESSION_ARG_28 VARCHAR(100)  ,
                  EXPRESSION_ARG_29 VARCHAR(100)  ,
                  EXPRESSION_ARG_30 VARCHAR(100)  ,
                  EXPRESSION_ARG_31 VARCHAR(100)  ,
                  EXPRESSION_ARG_32 VARCHAR(100)  ,
                  CREATE_TIMESTAMP TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
                  LSTUPDT_TIMESTAMP TIMESTAMP ,
                  LOGICAL_DEL_IND CHAR(1) NOT NULL DEFAULT '0' )   UNIQUE PRIMARY INDEX ( EXPRESSION_ID )
 ;
 COMMIT WORK;

 CREATE UNIQUE INDEX AKX1_EXPR ( RULE_TEMPLATE_ID
		,EXPRESSION_ARG_1
		,EXPRESSION_ARG_2
		,EXPRESSION_ARG_3
		,EXPRESSION_ARG_4
		,EXPRESSION_ARG_5
		,EXPRESSION_ARG_6
		,EXPRESSION_ARG_7
		,EXPRESSION_ARG_8
		,EXPRESSION_ARG_9
		,EXPRESSION_ARG_10
		,EXPRESSION_ARG_11
		,EXPRESSION_ARG_12
		,EXPRESSION_ARG_13
		,EXPRESSION_ARG_14
		,EXPRESSION_ARG_15
		,EXPRESSION_ARG_16
		,EXPRESSION_ARG_17
		,EXPRESSION_ARG_18
		,EXPRESSION_ARG_19
		,EXPRESSION_ARG_20
		,EXPRESSION_ARG_21
		,EXPRESSION_ARG_22
		,EXPRESSION_ARG_23
		,EXPRESSION_ARG_24
		,EXPRESSION_ARG_25
		,EXPRESSION_ARG_26
		,EXPRESSION_ARG_27
		,EXPRESSION_ARG_28
		,EXPRESSION_ARG_29
		,EXPRESSION_ARG_30
		,EXPRESSION_ARG_31
		,EXPRESSION_ARG_32 )
 ON FRH_EXPRESSION_ARGUMENTS;
 commit work;



ALTER TABLE FRH_EXPRESSION_ARGUMENTS
     ADD CONSTRAINT CK_CHAR_ZERO_ONE
    CHECK (LOGICAL_DEL_IND IN ('0', '1')) ;
 COMMIT WORK;
------------------------------------------------
-- DDL Statements for table FRH_EXPRESSION_RESULTS
------------------------------------------------
CREATE TABLE FRH_EXPRESSION_RESULTS, NO FALLBACK   (
                  EXPRESSION_ID BIGINT NOT NULL ,
                  STRING_RESULT VARCHAR(60) ,
                  LONG_RESULT BIGINT ,
                  CREATE_TIMESTAMP TIMESTAMP NOT NULL DEFAULT  CURRENT_TIMESTAMP ) ;
 COMMIT WORK;
 









